/********************************************************************
 * NOTE: This source code is free and comes 
 * with ABSOLUTELY NO WARRANTY.
 * 
 * @author Daniel Muenter, 2007
 *  
 ********************************************************************/
var PrefObserver = {
	
	prefs: null,
	bool: "",
	
	// Initialize the extension
	startup: function()	{
		// Register to receive notifications of preference changes
		this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
				.getService(Components.interfaces.nsIPrefService)
				.getBranch("extensions.feedbackfox.");
		this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		this.prefs.addObserver("", this, false);
	},
	
	// Clean up after ourselves and save the prefs
	shutdown: function() {
		this.prefs.removeObserver("", this);
	},
	
	// Called when events occur on the preferences
	observe: function(subject, topic, data)	{
		if (topic != "nsPref:changed") {
			return;
		}
		switch(data) {
			case "showfbftbarbutton":
				this.bool = this.prefs.getBoolPref("showfbftbarbutton");
				this.toggleToolbarButton();
				break;
		}
	},
	
	// Toggles the feedbackfox toolbar button
	toggleToolbarButton: function() {
		// extensions.feedbackfox.showfbftbarbutton
		var button = document.getElementById("feedbackfox-toolbarbutton");
		if (this.bool && !button) {
			var insertBeforeBtn = 'urlbar-container';
			var toolbar = document.getElementById("nav-bar");
			if (toolbar && "insertItem" in toolbar) {
				var insertBefore = (insertBeforeBtn ? document.getElementById(insertBeforeBtn) : null);
				if (insertBefore && insertBefore.parentNode != toolbar)
					insertBefore = null;
				toolbar.insertItem("feedbackfox-toolbarbutton", insertBefore, null, false);
				toolbar.setAttribute("currentset", toolbar.currentSet);
				document.persist(toolbar.id, "currentset");
			}
		} else if (!this.bool && button) {
			var parent = button.parentNode;
			parent.removeChild(button);
			var toolbar = document.getElementById("nav-bar");
			toolbar.setAttribute("currentset", toolbar.currentSet);
			document.persist(toolbar.id, "currentset");
		}
	}
}

// Install load and unload handlers
window.addEventListener("load", function(e) { PrefObserver.startup(); }, false);
window.addEventListener("unload", function(e) { PrefObserver.shutdown(); }, false);